import _extends from "@babel/runtime/helpers/extends";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import { MuiPickersUtilsProvider, TimePicker as MUITimePicker } from '@material-ui/pickers';
import MomentUtils from '@date-io/moment';
import FormFieldGrid from '../form-field-grid/form-field-grid';
import { validationError } from '../validation-error/validation-error';
import { meta, input } from '@data-driven-forms/common/prop-types-templates';
import useFieldApi from "@data-driven-forms/react-form-renderer/use-field-api";

var TimePicker = function TimePicker(props) {
  var _useFieldApi = useFieldApi(props),
      input = _useFieldApi.input,
      isReadOnly = _useFieldApi.isReadOnly,
      isDisabled = _useFieldApi.isDisabled,
      placeholder = _useFieldApi.placeholder,
      isRequired = _useFieldApi.isRequired,
      label = _useFieldApi.label,
      helperText = _useFieldApi.helperText,
      description = _useFieldApi.description,
      validateOnMount = _useFieldApi.validateOnMount,
      meta = _useFieldApi.meta,
      _useFieldApi$locale = _useFieldApi.locale,
      locale = _useFieldApi$locale === void 0 ? 'en' : _useFieldApi$locale,
      MuiPickersUtilsProviderProps = _useFieldApi.MuiPickersUtilsProviderProps,
      FormFieldGridProps = _useFieldApi.FormFieldGridProps,
      rest = _objectWithoutProperties(_useFieldApi, ["input", "isReadOnly", "isDisabled", "placeholder", "isRequired", "label", "helperText", "description", "validateOnMount", "meta", "locale", "MuiPickersUtilsProviderProps", "FormFieldGridProps"]);

  var invalid = validationError(meta, validateOnMount);
  return /*#__PURE__*/React.createElement(FormFieldGrid, FormFieldGridProps, /*#__PURE__*/React.createElement(MuiPickersUtilsProvider, _extends({
    locale: locale,
    utils: MomentUtils
  }, MuiPickersUtilsProviderProps), /*#__PURE__*/React.createElement(MUITimePicker, _extends({
    fullWidth: true,
    margin: "normal",
    label: label,
    helperText: invalid || (meta.touched || validateOnMount) && meta.warning || helperText || description,
    disabled: isDisabled || isReadOnly,
    placeholder: placeholder,
    required: isRequired,
    error: !!invalid,
    readOnly: isReadOnly
  }, input, {
    value: input.value || null
  }, rest))));
};

TimePicker.propTypes = {
  input: input,
  meta: meta,
  isReadOnly: PropTypes.bool,
  isDisabled: PropTypes.bool,
  placeholder: PropTypes.node,
  isRequired: PropTypes.bool,
  label: PropTypes.node,
  helperText: PropTypes.node,
  validateOnMount: PropTypes.bool,
  locale: PropTypes.string,
  description: PropTypes.node,
  FormFieldGridProps: PropTypes.object,
  MuiPickersUtilsProviderProps: PropTypes.object
};
TimePicker.defaultProps = {
  FormFieldGridProps: {},
  MuiPickersUtilsProviderProps: {}
};
export default TimePicker;